/**
 * @file FootyViewScroll
 * @brief Footỹr[Ǘs܂B̃t@CŃXN[֌W̏s܂B
 * @author Shinji Watanabe
 * @version 1.0
 */

#include "FootyView.h"

/**
 * CFootyView::SetBars
 * @brief XN[o[݂̃oϐp[^ɏ]Đݒ肵܂B
 */
void CFootyView::SetBars(){
	/*錾*/
	size_t nEthicLines;
	LinePt pLastLine = m_pDocuments->GetLastLine();
	
	/*\łʂvZ*/
	nEthicLines = pLastLine->GetOffset();
	nEthicLines += pLastLine->GetEthicLine();
	
	/*XN[o[*/
	m_vInfo.cbSize = sizeof(SCROLLINFO);
	m_vInfo.fMask = SIF_ALL;
	if (nEthicLines == 1)		/*ŝƂ́A\s{P̒l*/
		m_vInfo.nMax = (int)m_nVisibleLines;
	else						/*ȊÔƂ́Aŉsԏɂ悤*/
		m_vInfo.nMax = (int)(m_nVisibleLines + nEthicLines - 2);
	m_vInfo.nMin=0;
	m_vInfo.nPage = (unsigned)m_nVisibleLines;
	m_vInfo.nPos = (int)(m_pDocuments->GetFirstVisible(m_nViewID)->
		GetLinePointer()->GetOffset() +
		m_pDocuments->GetFirstVisible(m_nViewID)->GetEthicNum());
	m_vInfo.nTrackPos = 0;
	SetScrollInfo(m_hWnd,SB_VERT,&m_vInfo,true);

	if (m_nVisibleColumns <= m_pDocuments->GetLapelColumn()){
		/*XN[o[\*/
		m_hInfo.cbSize=sizeof(SCROLLINFO);
		m_hInfo.fMask=SIF_ALL;
		m_hInfo.nMax = (int)(m_pDocuments->GetLapelColumn() + m_nVisibleColumns - 2);
		m_hInfo.nMin = 0;
		m_hInfo.nPage = (int)m_nVisibleColumns;
		m_hInfo.nPos = (int)m_nFirstVisibleColumn;
		m_hInfo.nTrackPos = 0;
		SetScrollInfo(m_hWnd,SB_HORZ,&m_hInfo,true);
	}
	else{
		/*XN[o[͔\*/
		m_hInfo.cbSize=sizeof(SCROLLINFO);
		m_hInfo.fMask=SIF_ALL;
		m_hInfo.nMax=0;
		m_hInfo.nMin=0;
		m_hInfo.nPage=0;
		m_hInfo.nPos=0;
		m_hInfo.nTrackPos=0;
		SetScrollInfo(m_hWnd,SB_HORZ,&m_hInfo,true);
	}
}

// ̕ӂ
int g_dy;
/**
 * CFootyView::OnVScroll
 * @brief XN[o[삳ꂽƂɌĂ΂܂B
 * @param wParam EBhEbZ[WWPARAMp܂
 */

/*
void CFootyView::OnVScroll(WPARAM wParam){
	int dy;                   // XN[
	SCROLLINFO sbInfo;

	switch (LOWORD(wParam)) {
	case SB_LINEUP:
		g_dy = -1; 
		return;                // Op{^
	case SB_LINEDOWN:
		g_dy = 1;
		return;                // Op{^
	case SB_PAGEUP:           // 傱ƊԂ
		g_dy = -1*m_vInfo.nPage;
		return;
	case SB_PAGEDOWN:         // 傱ƊԂ
		g_dy = m_vInfo.nPage;
		return;
	case SB_THUMBPOSITION:    // XN[肮蓮
	case SB_THUMBTRACK:       // XN[肮蓮
		ZeroMemory(&sbInfo, sizeof(SCROLLINFO));
		sbInfo.cbSize = sizeof(SCROLLINFO);
		sbInfo.fMask = SIF_TRACKPOS;
		GetScrollInfo(m_hWnd,SB_VERT,&sbInfo);
		g_dy = sbInfo.nTrackPos - m_vInfo.nPos;
		return;
	case SB_ENDSCROLL:
		dy = g_dy;
		break;
    default:
		return;
    }

	// ŏɕ\Ăsړ
	if (dy < 0)m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicBack(-dy);
	else m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicNext(m_pDocuments->GetLineList(),dy);

	// ĕ`悳
	ScrollRefresh();
}
*/
void CFootyView::OnVScroll(WPARAM wParam){
	/*錾*/
	int dy;                   // XN[
	SCROLLINFO sbInfo;

	switch (LOWORD(wParam)) {
	case SB_LINEUP:
		dy = -1; 
		break;                // Op{^
	case SB_LINEDOWN:
		dy = 1;
		break;                // Op{^
	case SB_PAGEUP:           // 傱ƊԂ
		dy = -1*m_vInfo.nPage;
		break;
	case SB_PAGEDOWN:         // 傱ƊԂ
		dy = m_vInfo.nPage;
		break;
	case SB_THUMBPOSITION:    // XN[肮蓮
	case SB_THUMBTRACK:       // XN[肮蓮
		ZeroMemory(&sbInfo, sizeof(SCROLLINFO));
		sbInfo.cbSize = sizeof(SCROLLINFO);
		sbInfo.fMask = SIF_TRACKPOS;
		GetScrollInfo(m_hWnd,SB_VERT,&sbInfo);
		dy = sbInfo.nTrackPos - m_vInfo.nPos;
		break;
    default:
		return;
    }

	// ŏɕ\Ăsړ
	if (dy < 0)m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicBack(-dy);
	else m_pDocuments->GetFirstVisible(m_nViewID)->MoveEthicNext(m_pDocuments->GetLineList(),dy);

	// ĕ`悳
	if (m_ImgCtr->IsLoaded()){
		Refresh();// wi摜ǂ܂Ăꍇ́Accׂׂčĕ`悷
	}else{
		ScrollRefresh();
	}
}

/**
 * CFootyView::OnHScroll
 * @brief XN[ꂽƂ̏
 * @param wParam EBhEbZ[W̒lp
 */
void CFootyView::OnHScroll(WPARAM wParam){
	int dx;                   /*XN[*/

	switch (LOWORD(wParam)) {
	case SB_LINEUP:
		dx=-1; 
		break;                /*Op{^*/
	case SB_LINEDOWN:
		dx=1;
		break;                /*Op{^*/
	case SB_PAGEUP:           /*傱ƊԂ*/
		dx = -1 * m_hInfo.nPage;
		break;
	case SB_PAGEDOWN:         /*傱ƊԂ*/
		dx = m_hInfo.nPage;
		break;
	case SB_THUMBPOSITION:    /*XN[肮蓮*/
	case SB_THUMBTRACK:       /*XN[肮蓮*/
		dx = HIWORD(wParam) - m_hInfo.nPos;
		break;
    default:
		return;
    }

	m_nFirstVisibleColumn += dx;
	if (m_nFirstVisibleColumn < 0)m_nFirstVisibleColumn = 0;
	if (m_nFirstVisibleColumn > (int)m_pDocuments->GetLapelColumn())
		m_nFirstVisibleColumn = (int)m_pDocuments->GetLapelColumn();
	
	Refresh();
}

/*[EOF]*/
